diff -ruN ../nakedmudv2.7/src/cmd_misc.c src/cmd_misc.c
--- ../nakedmudv2.7/src/cmd_misc.c	Sun Jul 31 17:13:52 2005
+++ src/cmd_misc.c	Fri Oct  7 14:15:55 2005
@@ -6,18 +6,17 @@
 //
 //*****************************************************************************
 #include "mud.h"
+#include "utils.h"
 #include "character.h"
 #include "socket.h"
-#include "utils.h"
 #include "save.h"
 #include "event.h"
 #include "action.h"
-#include "handler.h"
+
 
 
 //
 // stop performing the character's current action
-//
 COMMAND(cmd_stop) {
 #ifdef MODULE_FACULTY
   if(!is_acting(ch, FACULTY_ALL))
@@ -35,7 +34,6 @@
 
 //
 // clear the screen
-//
 COMMAND(cmd_clear) {
   send_to_char(ch, "\033[H\033[J");
 }
@@ -43,15 +41,9 @@
 
 //
 // quit the game
-//
-COMMAND(cmd_quit)
-{
-  char buf[MAX_BUFFER];
-
-  /* log the attempt */
-  sprintf(buf, "%s has left the game.", charGetName(ch));
-  log_string(buf);
-
+COMMAND(cmd_quit) {
+  // log the attempt
+  log_string("%s has left the game.", charGetName(ch));
   save_player(ch);
 
   // 
@@ -70,9 +62,7 @@
 
 //
 // save the character
-//
-COMMAND(cmd_save)
-{
+COMMAND(cmd_save) {
   save_player(ch);
   text_to_char(ch, "Saved.\r\n");
 }
@@ -80,37 +70,26 @@
 
 //
 // the function for executing a delayed command
-//
 void event_delayed_cmd(CHAR_DATA *ch, void *data, char *cmd) {
-  do_cmd(ch, cmd, TRUE, TRUE);
+  do_cmd(ch, cmd, TRUE);
 }
 
 
 //
 // Perform a command, but delay its execution by a couple seconds
-//
 COMMAND(cmd_delay) {
-  if(!arg || !*arg) {
-    send_to_char(ch, "What did you want to delay, and by how long?\r\n");
-    return;
-  }
+  int       secs = 0;
+  char *to_delay = NULL;
 
-  // how long should we delay, in seconds?
-  char time[SMALL_BUFFER];
-  arg = one_arg(arg, time);
-
-  // no command to delay
-  if(!*arg) {
-    send_to_char(ch, "What command did you want to delay?\r\n");
+  if(!parse_args(ch, TRUE, cmd, arg, "int string", &secs, &to_delay))
     return;
-  }
-  if(atoi(time) < 1) {
+
+  if(secs < 1)
     send_to_char(ch, "You can only delay commands for positive amounts of time.\r\n");
-    return;
+  else {
+    send_to_char(ch, "You delay '%s' for %d seconds.\r\n", to_delay, secs);
+    start_event(ch, secs SECONDS, event_delayed_cmd, NULL, NULL, to_delay);
   }
-
-  send_to_char(ch, "You delay '%s' for %d seconds.\r\n", arg, atoi(time));
-  start_event(ch, atoi(time) SECONDS, event_delayed_cmd, NULL, NULL, arg);
 }
 
 //
@@ -119,5 +98,5 @@
   // only bother sending it if we have a socket. And then page it, incase
   // the motd is especially long.
   if(charGetSocket(ch))
-    page_string(charGetSocket(ch), motd);
+    page_string(charGetSocket(ch), bufferString(motd));
 }
diff -ruN ../nakedmudv2.7/src/command.c src/command.c
--- ../nakedmudv2.7/src/command.c	Wed Dec 31 17:00:00 1969
+++ src/command.c	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,226 @@
+//*****************************************************************************
+//
+// command.c
+//
+// A structure that holds all of the data tied to player commands. 
+// Specifically, the function that is executed and all of the restrictions on
+// its execution.
+//
+//*****************************************************************************
+
+#include <Python.h>
+#include <structmember.h>
+
+#include "mud.h"
+#include "utils.h"
+#include "action.h"
+#include "character.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "scripts/pyplugs.h"
+#include "scripts/pychar.h"
+
+
+
+//*****************************************************************************
+// local structs, defines, and functions
+//*****************************************************************************
+struct cmd_data {
+  char       *name;
+  CMD_PTR(func);
+  PyObject *pyfunc;
+  int      min_pos;
+  int      max_pos;
+  char *user_group;
+  bool      mob_ok;
+  bool  interrupts;
+};
+
+
+
+//*****************************************************************************
+// implementation of command.h
+//*****************************************************************************
+CMD_DATA *newCmd(const char *name, COMMAND(func), int min_pos, int max_pos,
+		 const char *user_group, bool mob_ok, bool interrupts) {
+  CMD_DATA *cmd   = malloc(sizeof(CMD_DATA));
+  cmd->name       = strdupsafe(name);
+  cmd->func       = func;
+  cmd->min_pos    = min_pos;
+  cmd->max_pos    = max_pos;
+  cmd->user_group = strdupsafe(user_group);
+  cmd->mob_ok     = mob_ok;
+  cmd->interrupts = interrupts;
+  cmd->pyfunc     = NULL;
+  return cmd;
+}
+
+CMD_DATA *newPyCmd(const char *name, void *pyfunc, int min_pos, int max_pos,
+		 const char *user_group, bool mob_ok, bool interrupts) {
+  CMD_DATA *cmd   = malloc(sizeof(CMD_DATA));
+  cmd->name       = strdupsafe(name);
+  cmd->func       = NULL;
+  cmd->min_pos    = min_pos;
+  cmd->max_pos    = max_pos;
+  cmd->user_group = strdupsafe(user_group);
+  cmd->mob_ok     = mob_ok;
+  cmd->interrupts = interrupts;
+  cmd->pyfunc     = pyfunc;
+  Py_INCREF(cmd->pyfunc);
+  return cmd;
+}
+
+void deleteCmd(CMD_DATA *cmd) {
+  if(cmd->name)       free(cmd->name);
+  if(cmd->user_group) free(cmd->user_group);
+  if(cmd->pyfunc)     { Py_DECREF(cmd->pyfunc); }
+  free(cmd);
+}
+
+CMD_DATA *cmdCopy(CMD_DATA *cmd) {
+  if(cmd->func)
+    return newCmd(cmd->name, cmd->func, cmd->min_pos, cmd->max_pos,
+		  cmd->user_group, cmd->mob_ok, cmd->interrupts);
+  else
+    return newPyCmd(cmd->name, cmd->pyfunc, cmd->min_pos, cmd->max_pos,
+		    cmd->user_group, cmd->mob_ok, cmd->interrupts);
+}
+
+void cmdCopyTo(CMD_DATA *from, CMD_DATA *to) {
+  if(to->name)       free(to->name);
+  if(to->user_group) free(to->user_group);
+  if(to->pyfunc)     { Py_DECREF(to->pyfunc); }
+  *to = *from;
+  to->name         = strdup(from->name);
+  to->user_group   = strdup(from->user_group);
+  if(to->pyfunc)     { Py_INCREF(to->pyfunc); }
+}
+
+const char *cmdGetName(CMD_DATA *cmd) {
+  return cmd->name;
+}
+
+const char *cmdGetUserGroup(CMD_DATA *cmd) {
+  return cmd->user_group;
+}
+
+int cmdGetMinPos(CMD_DATA *cmd) {
+  return cmd->min_pos;
+}
+
+int cmdGetMaxPos(CMD_DATA *cmd) {
+  return cmd->max_pos;
+}
+
+bool cmdGetMobOk(CMD_DATA *cmd) {
+  return cmd->mob_ok;
+}
+
+bool cmdGetInterrupts(CMD_DATA *cmd) {
+  return cmd->interrupts;
+}
+
+
+//
+// make sure the character is in a position where this can be performed
+bool min_pos_ok(CHAR_DATA *ch, int minpos) {
+  if(poscmp(charGetPos(ch), minpos) >= 0)
+    return TRUE;
+  else {
+    switch(charGetPos(ch)) {
+    case POS_UNCONCIOUS:
+      send_to_char(ch, "You cannot do that while unconcious!\r\n");
+      break;
+    case POS_SLEEPING:
+      send_to_char(ch, "Not while sleeping, you won't!\r\n");
+      break;
+    case POS_SITTING:
+      send_to_char(ch, "You cannot do that while sitting!\r\n");
+      break;
+    case POS_STANDING:
+      // flying is the highest position... we can deduce this message
+      send_to_char(ch, "You must be flying to try that.\r\n");
+      break;
+    case POS_FLYING:
+      send_to_char(ch, "That is not possible in any position you can think of.\r\n");
+      break;
+    default:
+      send_to_char(ch, "Your position is all wrong!\r\n");
+      log_string("Character, %s, has invalid position, %d.",
+		 charGetName(ch), charGetPos(ch));
+      break;
+    }
+    return FALSE;
+  }
+}
+
+
+//
+// make sure the character is in a position where this can be performed
+bool max_pos_ok(CHAR_DATA *ch, int minpos) {
+  if(poscmp(charGetPos(ch), minpos) <= 0)
+    return TRUE;
+  else {
+    switch(charGetPos(ch)) {
+    case POS_UNCONCIOUS:
+      send_to_char(ch, "You're still too alive to try that!\r\n");
+      break;
+    case POS_SLEEPING:
+      send_to_char(ch, "Not while sleeping, you won't!\r\n");
+      break;
+    case POS_SITTING:
+      send_to_char(ch, "You cannot do that while sitting!\r\n");
+      break;
+    case POS_STANDING:
+      send_to_char(ch, "You cannot do that while standing.\r\n");
+      break;
+    case POS_FLYING:
+      send_to_char(ch, "You must land first.\r\n");
+      break;
+    default:
+      send_to_char(ch, "Your position is all wrong!\r\n");
+      log_string("Character, %s, has invalid position, %d.",
+		 charGetName(ch), charGetPos(ch));
+      break;
+    }
+    return FALSE;
+  }
+}
+
+
+bool charTryCmd(CHAR_DATA *ch, CMD_DATA *cmd, char *arg) {
+  if(!min_pos_ok(ch, cmd->min_pos) || !max_pos_ok(ch,cmd->max_pos) ||
+     (charIsNPC(ch) && !cmd->mob_ok))
+    return FALSE;
+  else {
+    if(cmd->interrupts) {
+#ifdef MODULE_FACULTY
+      interrupt_action(ch, FACULTY_ALL);
+#else
+      interrupt_action(ch, 1);
+#endif
+    }
+    if(cmd->func)
+      (cmd->func)(ch, cmd->name, arg);
+    else {
+      PyObject *arglist = Py_BuildValue("Oss", newPyChar(ch), cmd->name, arg);
+      PyObject *retval  = PyEval_CallObject(cmd->pyfunc, arglist);
+      // check for an error:
+      if(retval == NULL) {
+	char *tb = getPythonTraceback();
+	if(tb != NULL) {
+	  log_string("Error running python command, %s:\r\n%s\r\n", 
+		     cmd->name, tb);
+	  free(tb);
+	}
+      }
+      Py_XDECREF(retval);
+      Py_XDECREF(arglist);
+    }
+    return TRUE;
+  }
+}
diff -ruN ../nakedmudv2.7/src/command.h src/command.h
--- ../nakedmudv2.7/src/command.h	Wed Dec 31 17:00:00 1969
+++ src/command.h	Fri Oct  7 14:15:55 2005
@@ -0,0 +1,40 @@
+#ifndef COMMAND_H
+#define COMMAND_H
+//*****************************************************************************
+//
+// command.h
+//
+// A structure that holds all of the data tied to player commands. 
+// Specifically, the function that is executed and all of the restrictions on
+// its execution. For commands that are written as python functions, newPyCmd
+// is used, with the python function replacing the C function. The Python
+// function should take the same 3 arguments.
+//
+//*****************************************************************************
+
+typedef struct cmd_data CMD_DATA;
+
+#define CMD_PTR(name) \
+  void (* name)(CHAR_DATA *ch, const char *cmd, char *arg)
+#define COMMAND(name) \
+  void name(CHAR_DATA *ch, const char *cmd, char *arg)
+
+CMD_DATA   *newCmd(const char *name, COMMAND(func), int min_pos, int max_pos,
+		   const char *user_group, bool mob_ok, bool interrupts);
+CMD_DATA *newPyCmd(const char *name, void  *pyfunc, int min_pos, int max_pos,
+		   const char *user_group, bool mob_ok, bool interrupts);
+
+void     deleteCmd(CMD_DATA *cmd);
+CMD_DATA  *cmdCopy(CMD_DATA *cmd);
+void     cmdCopyTo(CMD_DATA *from, CMD_DATA *to);
+
+bool    charTryCmd(CHAR_DATA *ch, CMD_DATA *cmd, char *arg);
+
+const char      *cmdGetName(CMD_DATA *cmd);
+const char *cmdGetUserGroup(CMD_DATA *cmd);
+int            cmdGetMinPos(CMD_DATA *cmd);
+int            cmdGetMaxPos(CMD_DATA *cmd);
+bool            cmdGetMobOk(CMD_DATA *cmd);
+bool       cmdGetInterrupts(CMD_DATA *cmd);
+
+#endif // COMMAND_H
diff -ruN ../nakedmudv2.7/src/commands.h src/commands.h
--- ../nakedmudv2.7/src/commands.h	Sun Jul 31 17:13:52 2005
+++ src/commands.h	Fri Oct  7 14:15:55 2005
@@ -18,28 +18,24 @@
 COMMAND(cmd_at);
 COMMAND(cmd_lockdown);
 COMMAND(cmd_force);
+COMMAND(cmd_pulserate);
 
 
 /* cmd_builder.c */
-COMMAND(cmd_dig);
-COMMAND(cmd_fill);
 COMMAND(cmd_load);
 COMMAND(cmd_purge);
 COMMAND(cmd_zreset);
-COMMAND(cmd_buildwalk);
-COMMAND(cmd_sclist);
 COMMAND(cmd_rlist);
 COMMAND(cmd_mlist);
 COMMAND(cmd_olist);
-COMMAND(cmd_dlist);
 COMMAND(cmd_zlist);
-COMMAND(cmd_scdelete);
 COMMAND(cmd_rdelete);
 COMMAND(cmd_mdelete);
 COMMAND(cmd_odelete);
-COMMAND(cmd_ddelete);
-COMMAND(cmd_detach);
-COMMAND(cmd_attach);
+COMMAND(cmd_mrename);
+COMMAND(cmd_rrename);
+COMMAND(cmd_orename);
+COMMAND(cmd_rreload);
 
 
 /* cmd_manip.c */
@@ -73,9 +69,6 @@
 COMMAND(cmd_save);
 COMMAND(cmd_commands);
 COMMAND(cmd_compress);
-COMMAND(cmd_more);
-COMMAND(cmd_back);
-COMMAND(cmd_stop);
 COMMAND(cmd_motd);
 
 
@@ -85,16 +78,9 @@
 COMMAND(cmd_inventory);
 COMMAND(cmd_equipment);
 COMMAND(cmd_groupcmds);
-
-
-/* olc.c */
-COMMAND(cmd_redit);
-COMMAND(cmd_medit);
-COMMAND(cmd_oedit);
-COMMAND(cmd_zedit);
-COMMAND(cmd_wedit);
-COMMAND(cmd_scedit);
-COMMAND(cmd_dedit);
+COMMAND(cmd_more);
+COMMAND(cmd_back);
+COMMAND(cmd_stop);
 
 
 /* movement.c */
@@ -104,6 +90,5 @@
 COMMAND(cmd_wake);
 COMMAND(cmd_sleep);
 COMMAND(cmd_enter);
-
 
 #endif // __COMMAND_H
diff -ruN ../nakedmudv2.7/src/editor/editor.c src/editor/editor.c
--- ../nakedmudv2.7/src/editor/editor.c	Sun Jul 31 17:13:52 2005
+++ src/editor/editor.c	Fri Oct  7 14:15:55 2005
@@ -70,20 +70,20 @@
   void (* func)(SOCKET_DATA *sock, char *arg, BUFFER *buf);
   char *desc;    // the one-line helpfile description
   bool reserved; // is this command protected from being written over?
-} CMD_DATA;
+} ECMD_DATA;
 
-CMD_DATA *
+ECMD_DATA *
 newEditorCommand(const char *desc, 
 		 void func(SOCKET_DATA *sock, char *arg, BUFFER *buf),
 		 bool reserved) {
-  CMD_DATA *cmd = malloc(sizeof(CMD_DATA));
+  ECMD_DATA *cmd = malloc(sizeof(ECMD_DATA));
   cmd->desc     = strdup(desc ? desc : "");
   cmd->func     = func;
   cmd->reserved = reserved;
   return cmd;
 }
 
-void deleteEditorCommand(CMD_DATA *cmd) {
+void deleteEditorCommand(ECMD_DATA *cmd) {
   if(cmd->desc) free(cmd->desc);
   free(cmd);
 }
@@ -143,7 +143,7 @@
     arg = one_arg(arg, buf);
 
     // pull up the command
-    CMD_DATA *cmd = hashGet(data->editor->cmds, buf+1);
+    ECMD_DATA *cmd = hashGet(data->editor->cmds, buf+1);
     if(cmd == NULL)
       text_to_buffer(sock, "Invalid command.\r\n");
     else
@@ -176,7 +176,7 @@
 
 void editorDisplayHelp(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
   const char *key = NULL;
-  CMD_DATA   *val = NULL;
+  ECMD_DATA   *val = NULL;
   HASH_ITERATOR *hash_i = newHashIterator(socketGetEditor(sock)->cmds);
 
   // print out all of the commands and their descriptions
@@ -216,16 +216,12 @@
 }
 
 void editorListDialogBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
-  if(!*bufferString(buf))
-    text_to_buffer(sock, "Buffer contains not contents.\r\n");
-  else
+  if(*bufferString(buf))
     send_to_socket(sock, "%s\r\n", bufferString(buf));
 }
 
 void editorListBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
-  if(!*bufferString(buf))
-    text_to_buffer(sock, "Buffer contains not contents.\r\n");
-  else
+  if(*bufferString(buf))
     text_to_buffer(sock, bufferString(buf));
 }
 
@@ -271,7 +267,7 @@
 }
 
 void editorFormatBuffer(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
-  bufferFormat(buf, 80, 3);
+  bufferFormat(buf, SCREEN_WIDTH, PARA_INDENT);
   text_to_buffer(sock, "Buffer formatted.\r\n");
 }
 
@@ -355,7 +351,7 @@
 
 void editorAddCommand(EDITOR *editor, const char *cmd, const char *desc, 
 		      void func(SOCKET_DATA *sock, char *arg, BUFFER *buf)) {
-  CMD_DATA *old_cmd = hashGet(editor->cmds, cmd);
+  ECMD_DATA *old_cmd = hashGet(editor->cmds, cmd);
   // make sure we're not trying to replace a reserved command
   if(!old_cmd || !old_cmd->reserved) {
     hashPut(editor->cmds, cmd, newEditorCommand(desc, func, FALSE));
@@ -364,7 +360,7 @@
 }
 
 void editorRemoveCommand(EDITOR *editor, const char *cmd) {
-  CMD_DATA *old_cmd = hashGet(editor->cmds, cmd);
+  ECMD_DATA *old_cmd = hashGet(editor->cmds, cmd);
   // make sure the command isn't reserved
   if(old_cmd && !old_cmd->reserved) {
     hashRemove(editor->cmds, cmd);
@@ -382,7 +378,7 @@
   editorDefaultHeader(sock);
   
   // if we have a "list" command, execute it. Otherwise, cat the buf
-  CMD_DATA *list = NULL;
+  ECMD_DATA *list = NULL;
   if((list = hashGet(editor->cmds, "l")) != NULL)
     list->func(sock, "", buf);
   else
diff -ruN ../nakedmudv2.7/src/editor/notepad.c src/editor/notepad.c
--- ../nakedmudv2.7/src/editor/notepad.c	Sun Jul 31 17:13:52 2005
+++ src/editor/notepad.c	Fri Oct  7 14:15:55 2005
@@ -103,8 +103,8 @@
 				       NULL, NULL, NULL, NULL));
 
   // install our commands
-  add_cmd("write", NULL, cmd_write, 0, POS_SITTING, POS_FLYING,
+  add_cmd("write", NULL, cmd_write, POS_SITTING, POS_FLYING,
 	  "player", FALSE, TRUE);
-  add_cmd("notepad", NULL, cmd_notepad, 0, POS_SITTING, POS_FLYING,
+  add_cmd("notepad", NULL, cmd_notepad, POS_SITTING, POS_FLYING,
 	  "player", FALSE, TRUE);
 }
diff -ruN ../nakedmudv2.7/src/event.c src/event.c
--- ../nakedmudv2.7/src/event.c	Sun Jul 31 17:13:52 2005
+++ src/event.c	Fri Oct  7 14:15:55 2005
@@ -18,6 +18,7 @@
 #include "mud.h"
 #include "utils.h"
 #include "character.h"
+#include "hooks.h"
 #include "event.h"
 
 typedef struct event_data EVENT_DATA;
@@ -80,7 +81,7 @@
   event->delay             = delay;
   event->tot_time          = delay;
   event->data              = data;
-  event->arg               = strdup(arg ? arg :"");
+  event->arg               = strdupsafe(arg);
   event->requeue           = requeue;
   return event;
 }
@@ -95,25 +96,28 @@
     event->on_complete(event->owner, event->data, event->arg);
 }
 
+// the hook for interrupting events when something is removed from game
+void interrupt_events_hook(void *thing, void *none1, void *none2) {
+  interrupt_events_involving(thing);
+}
 
 
 
 //*****************************************************************************
-//
 // event list handling
-//
 //*****************************************************************************
 void init_events() {
   events = newList();
 
   // add our proof of concept command
-  add_cmd("devent", NULL, cmd_devent, 0, POS_SLEEPING, POS_FLYING,
+  add_cmd("devent", NULL, cmd_devent, POS_SLEEPING, POS_FLYING,
 	  "admin", TRUE, FALSE);
 
   // make sure all events involving the object/char are cancelled when
   // either is extracted from the game
-  add_extract_obj_func((void (*)(OBJ_DATA *)) interrupt_events_involving);
-  add_extract_mob_func((void (*)(CHAR_DATA *))interrupt_events_involving);
+  hookAdd("obj_from_game",  interrupt_events_hook);
+  hookAdd("char_from_game", interrupt_events_hook);
+  hookAdd("room_from_game", interrupt_events_hook);
 }
 
 void interrupt_event(EVENT_DATA *event) {
diff -ruN ../nakedmudv2.7/src/event.h src/event.h
--- ../nakedmudv2.7/src/event.h	Sun Jul 31 17:13:52 2005
+++ src/event.h	Fri Oct  7 14:15:55 2005
@@ -5,7 +5,7 @@
 // event.h
 //
 // this is the interface for the event handler. Events are temporally
-// delayed events. Events and actions (see action.h) may seem similar. They
+// delayed functions. Events and actions (see action.h) may seem similar. They
 // do, however, share some distinct differences. Whereas actions can only
 // be attached to characters, and only one action can be attached to a 
 // character at a time, events can be attached to anything, and anything can
diff -ruN ../nakedmudv2.7/src/exit.c src/exit.c
--- ../nakedmudv2.7/src/exit.c	Sun Jul 31 17:13:52 2005
+++ src/exit.c	Fri Oct  7 14:15:55 2005
@@ -16,10 +16,17 @@
 // lockable is handled if the exit has a key
 
 
+// exit UIDs (unique IDs) start at a million and go 
+// up by one every time a new exit is created
+#define START_EXIT_UID       1000000
+int next_exit_uid  =   START_EXIT_UID;
+
 struct exit_data {
   char *name;              // what is the name of our door for descriptions?
   char *keywords;          // what keywords can the door be referenced by?
   char *opposite;          // what is our opposite direction, if any?
+  char *to;                // where do we exit to?
+  char *key;               // what is the key's prototype?
   BUFFER *desc;            // what does a person see when they look at us?
 
   char *spec_enter;        // the message when we enter from this exit
@@ -28,11 +35,9 @@
   bitvector_t status;      // closable, closed, locked, etc...
 
   int closable;            // is the exit closable?
-  int key;            // what is the vnum of the key?
   int hide_lev;            // how hidden is this exit?
   int pick_lev;            // how hard is it to pick this exit?
-
-  int to;            // where do we exit to?
+  int uid;                 // our unique identification number
 };
 
 
@@ -44,13 +49,14 @@
   exit->opposite    = strdup("");
   exit->spec_enter  = strdup("");
   exit->spec_leave  = strdup("");
+  exit->to          = strdup("");
+  exit->key         = strdup("");
   exit->desc        = newBuffer(1);
-  exit->key         = NOTHING;
-  exit->to          = NOWHERE;
   exit->hide_lev    = 0;
   exit->pick_lev    = 0;
   exit->status      = 0;
   exit->closable    = FALSE;
+  exit->uid         = next_exit_uid++;
   return exit;
 };
 
@@ -61,6 +67,8 @@
   if(exit->spec_leave)  free(exit->spec_leave);
   if(exit->keywords)    free(exit->keywords);
   if(exit->opposite)    free(exit->opposite);
+  if(exit->to)          free(exit->to);
+  if(exit->key)         free(exit->key);
   if(exit->desc)        deleteBuffer(exit->desc);
 
   free(exit);
@@ -68,6 +76,7 @@
 
 
 void exitCopyTo(const EXIT_DATA *from, EXIT_DATA *to) {
+  exitSetTo       (to, exitGetTo(from));
   exitSetName     (to, exitGetName(from));
   exitSetKeywords (to, exitGetKeywords(from));
   exitSetDesc     (to, exitGetDesc(from));
@@ -85,9 +94,9 @@
 
 
 EXIT_DATA *exitCopy(const EXIT_DATA *exit) {
-  EXIT_DATA *E = newExit();
-  exitCopyTo(exit, E);
-  return E;
+  EXIT_DATA *newexit = newExit();
+  exitCopyTo(exit, newexit);
+  return newexit;
 }
 
 EXIT_DATA *exitRead(STORAGE_SET *set) {
@@ -98,8 +107,8 @@
   exitSetDesc(exit,      read_string(set, "desc"));
   exitSetSpecEnter(exit, read_string(set, "enter"));
   exitSetSpecLeave(exit, read_string(set, "leave"));
-  exitSetTo(exit,        read_int   (set, "to"));
-  exitSetKey(exit,       read_int   (set, "key"));
+  exitSetTo(exit,        read_string(set, "to"));
+  exitSetKey(exit,       read_string(set, "key"));
   exitSetHidden(exit,    read_int   (set, "hide_level"));
   exitSetPickLev(exit,   read_int   (set, "pick_level"));
   exitSetClosable(exit,  read_int   (set, "closable"));
@@ -114,8 +123,8 @@
   store_string(set, "desc",       bufferString(exit->desc));
   store_string(set, "enter",      exit->spec_enter);
   store_string(set, "leave",      exit->spec_leave);
-  store_int   (set, "to",         exit->to);
-  store_int   (set, "key",        exit->key);
+  store_string(set, "to",         exit->to);
+  store_string(set, "key",        exit->key);
   store_int   (set, "hide_level", exit->hide_lev);
   store_int   (set, "pick_level", exit->pick_lev);
   store_int   (set, "closable",   exit->closable);
@@ -124,13 +133,9 @@
 
 
 
-
 //*****************************************************************************
-//
 // is, get and set functions
-//
 //*****************************************************************************
-
 bool        exitIsClosable(const EXIT_DATA *exit) {
   return exit->closable;
 };
@@ -147,29 +152,33 @@
   return is_keyword(exit->keywords, name, TRUE);
 }
 
+int         exitGetUID(const EXIT_DATA *exit) {
+  return exit->uid;
+}
+
 int         exitGetHidden(const EXIT_DATA *exit) {
   return exit->hide_lev;
-};
+}
 
 int         exitGetPickLev(const EXIT_DATA *exit) {
   return exit->pick_lev;
-};
+}
 
-int    exitGetKey(const EXIT_DATA *exit) {
+const char *exitGetKey(const EXIT_DATA *exit) {
   return exit->key;
-};
+}
 
-int   exitGetTo(const EXIT_DATA *exit) {
+const char *exitGetTo(const EXIT_DATA *exit) {
   return exit->to;
-};
+}
 
 const char *exitGetName(const EXIT_DATA *exit) {
   return exit->name;
-};
+}
 
 const char *exitGetKeywords(const EXIT_DATA *exit) {
   return exit->keywords;
-};
+}
 
 const char *exitGetOpposite(const EXIT_DATA *exit) {
   return exit->opposite;
@@ -177,15 +186,15 @@
 
 const char *exitGetDesc(const EXIT_DATA *exit) {
   return bufferString(exit->desc);
-};
+}
 
 const char *exitGetSpecEnter(const EXIT_DATA *exit) {
   return exit->spec_enter;
-};
+}
 
 const char *exitGetSpecLeave(const EXIT_DATA *exit) {
   return exit->spec_leave;
-};
+}
 
 BUFFER *exitGetDescBuffer(const EXIT_DATA *exit) {
   return exit->desc;
@@ -193,45 +202,45 @@
 
 void        exitSetClosable(EXIT_DATA *exit, bool closable) {
   exit->closable = (closable != 0);
-};
+}
 
 void        exitSetClosed(EXIT_DATA *exit, bool closed) {
   if(closed)    SET_BIT(exit->status, EX_CLOSED);
   else          REMOVE_BIT(exit->status, EX_CLOSED);
-};
+}
 
 void        exitSetLocked(EXIT_DATA *exit, bool locked) {
   if(locked)    SET_BIT(exit->status, EX_LOCKED);
   else          REMOVE_BIT(exit->status, EX_LOCKED);
-};
+}
 
-void        exitSetKey(EXIT_DATA *exit, int key) {
-  exit->key = key;
-};
+void        exitSetKey(EXIT_DATA *exit, const char *key) {
+  if(exit->key) free(exit->key);
+  exit->key = strdupsafe(key);
+}
 
 void        exitSetHidden(EXIT_DATA *exit, int hide_lev) {
   exit->hide_lev = hide_lev;
-};
+}
 
 void        exitSetPickLev(EXIT_DATA *exit, int pick_lev) {
   exit->pick_lev = pick_lev;
-};
+}
 
-void        exitSetTo(EXIT_DATA *exit, int room) {
-  exit->to = room;
-};
+void        exitSetTo(EXIT_DATA *exit, const char *room) {
+  if(exit->to) free(exit->to);
+  exit->to = strdupsafe(room);
+}
 
 void        exitSetName(EXIT_DATA *exit, const char *name) {
   if(exit->name) free(exit->name);
-  if(name)       exit->name = strdup(name);
-  else           exit->name = strdup("");
-};
+  exit->name   = strdupsafe(name);
+}
 
 void        exitSetKeywords(EXIT_DATA *exit, const char *keywords) {
   if(exit->keywords) free(exit->keywords);
-  if(keywords)       exit->keywords = strdup(keywords);
-  else               exit->keywords = strdup("");
-};
+  exit->keywords   = strdupsafe(keywords);
+}
 
 void        exitSetOpposite(EXIT_DATA *exit, const char *opposite) {
   if(exit->opposite) free(exit->opposite);
@@ -241,16 +250,14 @@
 void        exitSetDesc(EXIT_DATA *exit, const char *desc) {
   bufferClear(exit->desc);
   bufferCat(exit->desc, (desc ? desc : ""));
-};
+}
 
 void        exitSetSpecEnter(EXIT_DATA *exit, const char *enter) {
   if(exit->spec_enter)  free(exit->spec_enter);
-  if(enter)             exit->spec_enter = strdup(enter);
-  else                  exit->spec_enter = strdup("");
-};
+  exit->spec_enter    = strdupsafe(enter);
+}
 
 void        exitSetSpecLeave(EXIT_DATA *exit, const char *leave) {
   if(exit->spec_leave)  free(exit->spec_leave);
-  if(leave)             exit->spec_leave = strdup(leave);
-  else                  exit->spec_leave = strdup("");
-};
+  exit->spec_leave    = strdupsafe(leave);
+}
diff -ruN ../nakedmudv2.7/src/exit.h src/exit.h
--- ../nakedmudv2.7/src/exit.h	Sun Jul 31 17:13:52 2005
+++ src/exit.h	Fri Oct  7 14:15:55 2005
@@ -46,20 +46,18 @@
 
 
 //*****************************************************************************
-//
 // is, get and set functions
-//
 //*****************************************************************************
-
 bool        exitIsName         (const EXIT_DATA *exit, const char *name);
 bool        exitIsClosable     (const EXIT_DATA *exit);
 bool        exitIsClosed       (const EXIT_DATA *exit);
 bool        exitIsLocked       (const EXIT_DATA *exit);
 
+int         exitGetUID         (const EXIT_DATA *exit);
 int         exitGetHidden      (const EXIT_DATA *exit);
 int         exitGetPickLev     (const EXIT_DATA *exit);
-int         exitGetKey         (const EXIT_DATA *exit);
-int         exitGetTo          (const EXIT_DATA *exit);
+const char *exitGetKey         (const EXIT_DATA *exit);
+const char *exitGetTo          (const EXIT_DATA *exit);
 const char *exitGetName        (const EXIT_DATA *exit);
 const char *exitGetKeywords    (const EXIT_DATA *exit);
 const char *exitGetOpposite    (const EXIT_DATA *exit);
@@ -71,10 +69,10 @@
 void        exitSetClosable    (EXIT_DATA *exit, bool closable);
 void        exitSetClosed      (EXIT_DATA *exit, bool closed);
 void        exitSetLocked      (EXIT_DATA *exit, bool locked);
-void        exitSetKey         (EXIT_DATA *exit, int key);
 void        exitSetHidden      (EXIT_DATA *exit, int hide_lev);
 void        exitSetPickLev     (EXIT_DATA *exit, int pick_lev);
-void        exitSetTo          (EXIT_DATA *exit, int room);
+void        exitSetKey         (EXIT_DATA *exit, const char *key);
+void        exitSetTo          (EXIT_DATA *exit, const char *key);
 void        exitSetName        (EXIT_DATA *exit, const char *name);
 void        exitSetOpposite    (EXIT_DATA *exit, const char *opposite);
 void        exitSetKeywords    (EXIT_DATA *exit, const char *keywords);
diff -ruN ../nakedmudv2.7/src/extra_descs.c src/extra_descs.c
--- ../nakedmudv2.7/src/extra_descs.c	Sun Jul 31 17:13:52 2005
+++ src/extra_descs.c	Fri Oct  7 14:15:55 2005
@@ -123,12 +123,7 @@
 }
 
 void        deleteEdescSet      (EDESC_SET *set) {
-  EDESC_DATA *entry;
-
-  while( (entry = listPop(set->edescs)) != NULL)
-    deleteEdesc(entry);
-
-  deleteList(set->edescs);
+  deleteListWith(set->edescs, deleteEdesc);
   free(set);
 }
 
@@ -140,36 +135,27 @@
   return set->edescs;
 }
 
-
-char       *tagEdescs           (EDESC_SET *set, const char *string,
-				 const char *start_tag, const char *end_tag) {
+void edescTagDesc(BUFFER *buf, EDESC_SET *set, 
+		  const char *start_tag, const char *end_tag) {
   LIST_ITERATOR *list_i = newListIterator(set->edescs);
   EDESC_DATA    *edesc  = NULL;
-  char          *newstring = strdup(string);
 
   // go through, and apply colors for each extra desc we have
   ITERATE_LIST(edesc, list_i) {
-    char *oldstring = newstring;
-    newstring = tag_keywords(edesc->keywords, oldstring, start_tag, end_tag);
-    free(oldstring);
-  }
-  deleteListIterator(list_i);
-
-  return newstring;
+    buf_tag_keywords(buf, edesc->keywords, start_tag, end_tag);
+  } deleteListIterator(list_i);
 }
 
 
 
 //*****************************************************************************
-//
 // a single edesc
-//
 //*****************************************************************************
 EDESC_DATA *newEdesc(const char *keywords, const char *desc) {
   EDESC_DATA *edesc = malloc(sizeof(struct edesc_data));
 
   edesc->set      = NULL;
-  edesc->keywords = strdup((keywords ? keywords : ""));
+  edesc->keywords = strdupsafe(keywords);
   edesc->desc     = newBuffer(1);
   bufferCat(edesc->desc, (desc ? desc : ""));
 
@@ -190,10 +176,10 @@
   // copy over the new desc
   bufferCopyTo(from->desc, to->desc);
   if(to->keywords) free(to->keywords);
-  to->keywords = strdup(from->keywords ? from->keywords : "");
+  to->keywords = strdupsafe(from->keywords);
 }
 
-const char *edescSetGetKeywords(EDESC_DATA *edesc) {
+const char *edescGetKeywords(EDESC_DATA *edesc) {
   return edesc->keywords;
 }
 
@@ -207,7 +193,7 @@
 
 void edescSetKeywords(EDESC_DATA *edesc, const char *keywords) {
   if(edesc->keywords) free(edesc->keywords);
-  edesc->keywords   = strdup((keywords ? keywords :""));
+  edesc->keywords   = strdupsafe(keywords);
 }
 
 void edescSetDesc(EDESC_DATA *edesc, const char *description) {
